﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.WindowsMobile.DirectX;
using Microsoft.WindowsMobile.DirectX.Direct3D;

namespace Direct3D
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        Device device;

        CustomVertex.PositionColored[] werteksyTrojkata = new CustomVertex.PositionColored[3]
        { 
            new CustomVertex.PositionColored(
                new Vector3(-1, -1, 0),
                Color.Red.ToArgb()),
            new CustomVertex.PositionColored(
                new Vector3(0, 1, 0),
                Color.Yellow.ToArgb()),
            new CustomVertex.PositionColored(
                new Vector3(1, -1, 0),
                Color.Green.ToArgb()) 
        };
        VertexBuffer buforWerteksow;

        public void Initialize()
        {
            //inicjacja urzadzenia
            PresentParameters pp = new PresentParameters();
            pp.Windowed = true;
            pp.SwapEffect = SwapEffect.Discard;
            device = new Device(
                0,
                DeviceType.Default,
                this,
                CreateFlags.None,
                pp);

            device.RenderState.Lighting = false;

            //bufor werteksow
            buforWerteksow = new VertexBuffer(
                typeof(CustomVertex.PositionColored),
                3,
                device,
                Usage.WriteOnly,
                CustomVertex.PositionColored.Format,
                Pool.SystemMemory);
            buforWerteksow.SetData(werteksyTrojkata, 0, LockFlags.None);
        }

        private void Draw()
        {
            device.Clear(ClearFlags.Target, Color.Black, 1.0f, 0);
            device.BeginScene();

            //w tym miejscu umieścimy polecenia rysowania obiektów 3D
            device.SetStreamSource(0, buforWerteksow, 0);
            device.DrawPrimitives(PrimitiveType.TriangleList, 0, 1);            

            device.EndScene();
            device.Present();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            Draw();
        }

        protected override void OnPaintBackground(PaintEventArgs e)
        {
        }
    }
}